{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,0}
uses dos;
const
{ str_info='CRLF v2.0 (c) 1999 Martin Petricek'#13#10+
  '----------------------------------'#13#10;
 str_usage='Convertor of text files from Unix to Dos format'#13#10+
  'Usage: crlf [file(s)]'#13#10+
  ' Wildcards are allowed, you can use multiple file specs.'#13#10+
  ' CRLF does not make any backups.'#13#10+
  ' Example: crlf *.txt *.htm index.doc'#13#10+
  ' CRLF is freeware, you can distribute it freely.'#13#10;
 str_done=' ...OK'#13#10;
 str_alldone='--- All done ---'#13#10;
 str_conv='Converting:';
 str_eopen=#13#10'Can''t open file: ';
 str_ewrite='Error writing data.'#13#10;
 str_eself=': Cannot convert self.'#13#10;
{}
 str_info='CRLF v2.0 (c) 1999 Martin Petricek'#13#10+
  '----------------------------------'#13#10;
 str_usage='Prevadec textu z formatu Unixu do Dosu'#13#10+
  'Pouziti: crlf [soubor(y)]'#13#10+
  ' Wildcards jsou dovoleny, je mozne napsat vice jmen souboru.'#13#10+
  ' CRLF nedela zadne zalozni soubory.'#13#10+
  ' Priklad: crlf *.txt page*.htm index.htm'#13#10+
  ' CRLF je freeware, muzete ho neomezene sirit.'#13#10;
 str_done=' ...OK'#13#10;
 str_alldone='--- Hotovo ---'#13#10;
 str_conv='Zpracovavam:';
 str_eopen=#13#10'Nelze otevrit soubor: ';
 str_ewrite='Chyba pri zapisu dat.'#13#10;
 str_eself=': Nemohu prevest sam sebe.'#13#10;
{}
 ent:byte=13;

var
 b:byte;
 s2:string;
 f1,f2:file;
 d2:longint;
 d:searchrec;
 nr,nw,i,j:word;
 bu:array[0..2047]of byte;
 bo:array[0..4095]of byte;

procedure writ(s:string);
begin
asm
 mov bx,0
 mov cl,byte ptr s
 xor ch,ch
 lea dx,s[1]
 mov ax,ss
 push ds
 mov ds,ax
 mov ah,40h
 int 21h
 pop ds
end;
end;

function paramstr0:string;assembler;
asm
@@1:	MOV	AH,30h{dosGetVersion}
	INT	21h
	CMP	AL,3
	MOV	AX,0
	JB	@@4
	MOV	ES,PrefixSeg
	MOV	ES,ES:word ptr 2Ch{pspEnvSeg}
	XOR	DI,DI
	CLD
@@2:	CMP	AL,ES:[DI]
	JE	@@3
	MOV	CX,-1
	REPNE	SCASB
	JMP	@@2
@@3:	ADD	DI,3
	MOV	SI,DI
	MOV	CX,256
	REPNE	SCASB
	XCHG	AX,CX
	NOT	AL
@@4:	PUSH	DS
	PUSH	ES
	POP	DS
	LES	DI,@result
	CLD
	STOSB
	XCHG	AX,CX
	REP	MOVSB
	POP	DS
end;

procedure error(s:string);
begin
 writ(s);
 halt;
end;

function mktchar:char;
begin
 mktchar:=chr(random(25)+ord('a'));
end;

begin
 writ(str_info);
 if (paramcount<1) then
 error(str_usage);
 randomize;
 repeat {mktempfile}
  s2:='~';for i:=1 to 7 do s2:=s2+mktchar;
  s2:=s2+'.~99';
  FindFirst(s2,Archive,D);
 until doserror<>0;
 for i:=1 to paramcount do
 begin
  FindFirst(paramstr(i),Archive,D);
  while (DosError = 0) do
  begin
{  d.name[ord(d.name[0])+1]:=#0;
   asm
mov ax,ds
mov es,ax
mov si,offset d.name+1
mov di,offset s1+1
mov ah,60h
int 21
mov bx,offset s1
mov si,bx
@beg:
inc si
cmp byte ptr ds:[si],0
je @end
inc byte ptr ds:[bx]
jmp @beg
@end:
end;
writ('source:');
writ(d.name);
writ('dest:');
writ(s1);}
   if paramstr0<>fexpand(d.name){chkselfdestruct}then
   begin
    writ(str_conv+d.name);
    assign(f1,d.name);
    assign(f2,s2);
    reset(f1,1);
    if ioresult<>0 then error(str_eopen+d.name);
    rewrite(f2,1);
    if ioresult<>0 then error(str_eopen+s2);
    nr:=1;
    while not(eof(f1)) do
    begin
     blockread(f1,bu,sizeof(bu),nr);
     nw:=0;
     if nr>0 then for j:=0 to nr-1 do
     begin
      case bu[j] of
{       10:begin blockwrite(f2,ent,1); blockwrite(f2,bu[j],1);end;
       13:;
       else blockwrite(f2,bu[j],1);}
       10:begin bo[nw]:=13;inc(nw);bo[nw]:=bu[j];inc(nw);end;
       13:;
       else begin bo[nw]:=bu[j];inc(nw);end;
      end;
     end;
     blockwrite(f2,bo,nw);
    end;
    close(f1);
    erase(f1);
    close(f2);
    rename(f2,d.name);
    if ioresult<>0 then error(str_ewrite);
    writ(str_done);
   end else begin
    writ(d.name);
    writ(str_eself);
   end;
   FindNext(D);
  end;
 end;
 writ(str_alldone);
end.